/*****************************************************************************
 * $Id: game_base_debug.hh,v 1.6 2005/06/22 23:53:45 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	Debug/profiling code.
 *//*
 * LEGAL:	COPYRIGHT (C) 2004 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 *****************************************************************************/

#if COMPILING_GAME

// ----- ! DEBUG ---------------------------------------------------------------

#if ! DEBUG
#define GAME_STATS_CODE( CODE )
#endif

// ----- DEBUG -----------------------------------------------------------------

#if DEBUG
#ifndef GAME_BASE_DEBUG_HH
#define GAME_BASE_DEBUG_HH 1

// Statistics code macro.
#undef  GAME_STATS_CODE
#if STATS && COMPILING_GAME
#define GAME_STATS_CODE( CODE ) { CODE }
#else
#define GAME_STATS_CODE( CODE )
#endif

//------------------------------------------------------------------------------

#if STATS

////////////////////////////////////////////////////////////////////////////////
/// @brief Statistics.
class GameStats
{
public:
			GameStats( void );
	void	PreDraw( void );

	int		mTracers;
};

ostream&
operator<<( ostream& strm, const GameStats& o );

#endif // STATS

//------------------------------------------------------------------------------

#endif // GAME_BASE_DEBUG_HH
#endif // DEBUG

#endif // COMPILING_GAME
