/*****************************************************************************
 * $Id: game_base_defs.hh,v 1.4 2006/07/07 02:19:53 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	Definitions, constants, settings.
 * @remarks @verbatim
 * ----------------------------------------------------------------------------
 * This header file should only contain self-contained constants (no dependencies).
 * C++ const is preferred to use type-checking but some must be #defined
 * as some source files test them using #if.
 * NOTE: Be sure to WRITE A PERIOD IN FLOAT CONSTANTS defined by #define
 * or integer instructions could be compiled (with loss of accuracy).
 * ----------------------------------------------------------------------------
 * @endverbatim
 *//*
 * LEGAL:	COPYRIGHT (C) 2004 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 *****************************************************************************/

#ifndef GAME_BASE_DEFS_HH
#define GAME_BASE_DEFS_HH 1

#include "eng_defs.hh"

#define INPUT_QUEUE_POLL_TIMER_MILSEC	40			///< do infreq as polling can be very slow on UNIX
#if INPUT_QUEUE_POLL_TIMER_MILSEC < DEFAULT_TIMER_MILSEC
#error "INPUT_QUEUE_POLL_TIMER_MILSEC < DEFAULT_TIMER_MILSEC"
#endif

#define DYNA_FRIENDS_AT_GAME_BASE \
	friend class PilotGame;
#ifdef DYNA_FRIENDS
#	define DYNA_FRIENDS \
           DYNA_FRIENDS \
		   DYNA_FRIENDS_AT_GAME_BASE
#else
#	define DYNA_FRIENDS DYNA_FRIENDS_AT_GAME_BASE
#endif

#endif // GAME_BASE_DEFS_HH
