/*****************************************************************************
 * $Id: game_base_listeners.hh,v 1.6 2005/09/06 13:53:44 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	Event listeners.
 *//*
 * LEGAL:	COPYRIGHT (C) 2004 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 *****************************************************************************/

#if COMPILING_GAME

// Reused for declaring listeners as friends of the game class.

#undef GAME_BASE_LISTENERS
#undef GAME_BASE_LISTENER_TYPE
#if GAME_BASE_LISTENERS_FRIEND
#	define GAME_BASE_LISTENERS			1
#	define GAME_BASE_LISTENER_TYPE		friend
#elif GAME_BASE_LISTENERS_CC
#	define GAME_BASE_LISTENERS			1
#	define GAME_BASE_LISTENER_TYPE
#endif

#if GAME_BASE_LISTENERS

GAME_BASE_LISTENER_TYPE void
Listener_GameBase_EngineReady( void );

GAME_BASE_LISTENER_TYPE void
Listener_GameBase_Exit( void );

GAME_BASE_LISTENER_TYPE void
Listener_GameBase_Animate( void );

GAME_BASE_LISTENER_TYPE void
Listener_GameBase_Tick( void );

GAME_BASE_LISTENER_TYPE void
Listener_GameBase_NeedTextureDirVec( void );

GAME_BASE_LISTENER_TYPE void
Listener_GameBase_PrintStats( void );

#endif // GAME_BASE_LISTENERS

#endif // COMPILING_GAME
