/*****************************************************************************
 * $Id: game_pony_debug.hh,v 1.3 2005/06/24 03:10:27 devel Exp $
 * @file
 * @author	Jim E. Brooks  http://www.jimbrooks.org
 * @brief	Debug/profiling support, statistics, etc.
 *//*
 * LEGAL:	COPYRIGHT (C) 2004 JIM E. BROOKS
 *          THIS SOURCE CODE IS RELEASED UNDER THE TERMS
 *          OF THE GNU GENERAL PUBLIC LICENSE (GPL).
 *****************************************************************************/

#if COMPILING_GAME
#if DEBUG
#ifndef GAME_PONY_DEBUG_HH
#define GAME_PONY_DEBUG_HH 1

//------------------------------------------------------------------------------

#if STATS

////////////////////////////////////////////////////////////////////////////////
/// @brief Statistics.
class GamePonyStats
{
public:
			GamePonyStats( void );
	void	PreDrawViews( void );

	int		mTracers;
	int		mLandQuadsDrawn;          ///< total drawn
	int		mLandQuadsDrawnTextured;  ///< draw textured
	int		mHills;
	int		mHillsDrawn;
	int		mTrees;
	int		mTreesDrawn;
	int		mLakes;
	int		mLakesDrawn;
};

ostream&
operator<<( ostream& strm, const GamePonyStats& o );

#endif // STATS

//------------------------------------------------------------------------------

#endif // GAME_PONY_DEBUG_HH
#endif // DEBUG
#endif // COMPILING_GAME
